# FIXME: this is a pretty bad RPM:
#  - It requires that gtm_curpro already exists on the build box
#  - It requires that gtm_dist does not already exist on the build box
#  - It requires the RPM be built as root
#  - The arch is wrong (?) - GT.M requires i686 but this package is marked i386
#  - It's unclear whether newer versions of GT.M can be parallel-installed

# This must point to an existing binary installation of GT.M because GT.M
# requires GT.M to build
%define gtm_curpro /tmp/gtm

%ifarch x86_64
%define gtm_dist /opt/lsb-gtm/V5.3-003_x86_64
%else
%define gtm_dist /opt/lsb-gtm/V5.3-003_i686
%endif

Name:		fis-gtm-5.3003
Version:	5.3003
Release:	1
Summary:	High end TP schemaless database
License:	AGPL
Vendor:		Fidelity Information Services
URL:		http://www.fidelityinfoservices.com/FNFIS/Markets/NonFinancialIndustries/Healthcare/GTM/
Group:		Applications/Databases
Packager:	Jonathan Tai <jon.tai@medsphere.com>

Provides:	fis-gtm

Requires(pre):		/usr/sbin/groupadd
Requires(post):		/usr/sbin/semanage, /sbin/restorecon
Requires(postun):	/usr/sbin/semanage, /usr/sbin/groupdel

Requires:	/bin/sh, coreutils, libicu, zlib, ncurses
BuildRequires:	/bin/tcsh, libicu-devel, zlib-devel, ncurses-devel

# The source for both i686 and x86_64 versions are both in this tarball, even
# though the tarball is named i686_src
Source:		gtm_V53003_linux_i686_src.tar.gz

# Patch the configure script to pre-answer all of the prompts and set the
# installation directory
Patch1:		fis-gtm-5.3003_noninteractive-configure.patch

# See https://bugs.launchpad.net/openvista-gtm-integration/+bug/327480
Patch2:		fis-gtm-5.3003_zprompt.patch

BuildRoot:	%{_tmppath}/%{name}-root

%description
GT.M is a vetted, industrial strength, transaction processing application
platform consisting of a schema-less database engine optimized for extreme
transaction processing throughput & business continuity plus a compiler for the
MUMPS language.

%prep
if [ ! -d "%{gtm_curpro}" ]; then
    echo "existing binary installation of GT.M not found at %{gtm_curpro}"
    exit 1
fi

if [ -d "%{gtm_dist}" ]; then
    echo "target GT.M directory %{gtm_dist} already exists"
    exit 1
fi

if ! grep '^gtm:' /etc/group > /dev/null; then
    echo "gtm group not found in /etc/group"
    exit 1
fi

if [ `/usr/bin/id -u` -ne 0 ]; then
    echo "this RPM must be built as root"
    exit 1
fi 
%setup -c
%patch2 -p0

%build
# GT.M needs to be built with tcsh, and with a bunch of environmental variables
# set.  Since we can't run tcsh interactively, we put all the setenv commands
# and the build command itself into a temporary script, then execute it with
# tcsh.
echo 'setenv gtm_curpro %{gtm_curpro}' > build.csh
echo 'setenv gtm_exe %{gtm_curpro}' >> build.csh
echo 'setenv gtm_tools '$(pwd)'/sr_linux' >> build.csh
echo 'setenv gtm_inc '$(pwd)'/sr_linux' >> build.csh
%ifarch x86_64
echo 'setenv OBJECT_MODE 64' >> build.csh
%endif
echo 'setenv gtm_version_change 1' >> build.csh
cat sr_unix/gtm_env.csh >> build.csh
echo 'make -f sr_unix/comlist.mk -I./sr_unix -I./sr_linux buildtypes=pro gtm_ver='$(pwd) >> build.csh
tcsh -b build.csh
rm -f build.csh

# Put a copy of the COPYING file in the pro directory so that it will be
# installed by the ./configure script later
cp COPYING pro

%install
rm -rf %{buildroot}

mkdir -p $(dirname %{gtm_dist})

cd pro
# We need to patch the configure script to pre-answer all of the prompts and
# set the installation directory
sed 's,@GTMDIST@,%{gtm_dist},' < %{PATCH1} | patch -p0 -b
chmod +x configure
./configure

mkdir -p %{buildroot}$(dirname %{gtm_dist})
mv %{gtm_dist} %{buildroot}$(dirname %{gtm_dist})

%clean
rm -rf %{buildroot}

%files
%defattr(-,-,-)
/opt/lsb-gtm

%pre
/usr/sbin/groupadd gtm 2> /dev/null || :

%post
# GT.M's installation script just chcon directly, but it won't have any effect
# on the target system (only on the build system, and then only if SELinux is
# enabled on the build system).  On the target system, we should use semanage
# to save the correct context for libgtmshr.so in the SELinux policy.  This
# will ensure that the file has the correct context, even after relabling. 
#
# See http://fedoraproject.org/wiki/PackagingDrafts/SELinux
/usr/sbin/semanage fcontext -a -t textrel_shlib_t %{gtm_dist}/libgtmshr.so 2>/dev/null || :
/sbin/restorecon %{gtm_dist}/libgtmshr.so || :

%postun
# Remove libgtmshr.so from the SELinux policy if we're removing the package
#
# See http://fedoraproject.org/wiki/PackagingDrafts/SELinux
if [ $1 -eq 0 ]; then
    /usr/sbin/semanage fcontext -d -t textrel_shlib_t %{gtm_dist}/libgtmshr.so 2>/dev/null || :
    /usr/sbin/groupdel gtm 2> /dev/null || :
fi
