Name:		openvista-libs
Version:	0.8
Release:	1
Summary:	GT.M External Calls for OpenVista
License:	AGPL
Vendor:		Medsphere Systems Corporation
URL:		https://medsphere.org/community/project/gtm
Group:		Applications/System
Packager:	Jonathan Tai <jon.tai@medsphere.com>

Requires:	pam
BuildRequires:	pam-devel

Source:		openvista-libs-%{version}.tar.bz2
BuildRoot:	%{_tmppath}/%{name}-root

%description
OpenVista is a cost-effective, open, trusted and complete EHR which enhances
patient safety, increases clinical and operational efficiency and provides an
opportunity to improve quality of care delivery.

This package provides a shared library that OpenVista code running in GT.M
calls out to for PAM authentication and duplicating a device onto a spawned
child's stdin/stdout.

%prep
%setup

%build
cd src/libopenvista
./compile.sh

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_libdir}/openvista
install -m 755 src/libopenvista/libopenvista.so %{buildroot}%{_libdir}/openvista

install -d %{buildroot}%{_datadir}/openvista
install -m 644 src/libopenvista/openvista.xc %{buildroot}%{_datadir}/openvista

install -d %{buildroot}%{_sysconfdir}/pam.d
cat > %{buildroot}%{_sysconfdir}/pam.d/openvista <<EOF
#%PAM-1.0
auth     include        system-auth
account  include        system-auth
password include        system-auth
session  include        system-auth
EOF
chmod 644 %{buildroot}%{_sysconfdir}/pam.d/openvista

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%{_libdir}/openvista/libopenvista.so
%{_datadir}/openvista/openvista.xc
%{_sysconfdir}/pam.d/openvista

