Name:		openvista-utils
Version:	0.8
Release:	1
Summary:	Utilities for configuring and managing OpenVista
License:	AGPL
Vendor:		Medsphere Systems Corporation
URL:		https://medsphere.org/community/project/gtm
Group:		Applications/System
Packager:	Jonathan Tai <jon.tai@medsphere.com>

Requires(pre):		/usr/sbin/useradd
Requires(post):		/sbin/chkconfig
Requires(preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/userdel

Requires:	/bin/bash, coreutils, openssh, /usr/bin/logger, /usr/bin/rsync, /bin/tar, /usr/bin/bzip2, /usr/bin/find, vixie-cron, fis-gtm, openvista-libs

# RPM should have a suggests tag...
# Suggests:	bash-completion, putty-tools, /usr/bin/pbzip2

Source:		openvista-utils-%{version}.tar.bz2
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-root

%description
OpenVista is a cost-effective, open, trusted and complete EHR which enhances
patient safety, increases clinical and operational efficiency and provides an
opportunity to improve quality of care delivery.

This package provides command-line utilities that aid in configuring and
managing OpenVista instances. 

%prep
%setup

%build

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_libdir}/openvista
install scripts/usr/lib/openvista/functions %{buildroot}%{_libdir}/openvista

install -d %{buildroot}%{_sbindir}/
install scripts/usr/sbin/ovinstanceadd %{buildroot}%{_sbindir}/
install scripts/usr/sbin/ovinstancedel %{buildroot}%{_sbindir}/
install scripts/usr/sbin/ovrestore %{buildroot}%{_sbindir}/

install -d %{buildroot}%{_bindir}/
install scripts/usr/bin/openvista %{buildroot}%{_bindir}/
install scripts/usr/bin/ovtied %{buildroot}%{_bindir}/
install scripts/usr/bin/ovbackup %{buildroot}%{_bindir}/
install scripts/usr/bin/ovpurgejournals %{buildroot}%{_bindir}/

install -d %{buildroot}%{_sysconfdir}/rc.d/init.d/
install scripts/etc/init.d/openvista_early %{buildroot}%{_sysconfdir}/rc.d/init.d/
install scripts/etc/init.d/openvista %{buildroot}%{_sysconfdir}/rc.d/init.d/

install -d %{buildroot}%{_sysconfdir}/bash_completion.d/
install -m 644 scripts/etc/bash_completion.d/openvista %{buildroot}%{_sysconfdir}/bash_completion.d/

install -d %{buildroot}%{_sysconfdir}/cron.d/
install -m 644 scripts/etc/cron.d/openvista %{buildroot}%{_sysconfdir}/cron.d/

install -d %{buildroot}%{_sysconfdir}/cron.daily/
install scripts/etc/cron.daily/openvista %{buildroot}%{_sysconfdir}/cron.daily/

install -d %{buildroot}/opt/openvista

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc COPYING
%{_libdir}/openvista/functions
%{_sbindir}/ovinstanceadd
%{_sbindir}/ovinstancedel
%{_sbindir}/ovrestore
%{_bindir}/openvista
%{_bindir}/ovtied
%{_bindir}/ovbackup
%{_bindir}/ovpurgejournals
%{_sysconfdir}/rc.d/init.d/openvista_early
%{_sysconfdir}/rc.d/init.d/openvista
%{_sysconfdir}/bash_completion.d/openvista
%config %{_sysconfdir}/cron.d/openvista
%{_sysconfdir}/cron.daily/openvista
%attr(2750,root,openvista) %dir /opt/openvista

%pre
/usr/sbin/useradd -G gtm openvista 2> /dev/null || :

%post
/sbin/chkconfig --add openvista_early
/sbin/chkconfig openvista_early on
/sbin/chkconfig --add openvista
/sbin/chkconfig openvista on

%preun
if [ $1 = 0 ]; then
    /sbin/chkconfig --del openvista_early
    /sbin/chkconfig --del openvista
fi

%postun
if [ $1 = 0 ]; then
    /usr/sbin/userdel openvista 2> /dev/null || :

    # if there are no users in the openvista group (other than the openvista
    # user), userdel will delete the group, but if there *are* other users, we
    # need to explicitly call groupdel
    /usr/sbin/groupdel openvista 2> /dev/null || :
fi

