/*
* Copyright (C) 2009 Medsphere Systems Corporation
*
* This program is free software; you can redistribute it and/or modify it
* solely under the terms of the GNU Affero General Public License version 3 as
* published by the Free Software Foundation.
* 
* This program is distributed in the hope that it will be useful, but WITHOUT
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License
* for more details.
* 
* You should have received a copy of the GNU Affero General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses>.
* 
* You can contact Medsphere Systems Corporation headquarters at 1917 Palomar 
* Oaks Way, Suite 200, Carlsbad, CA 92008 or at legal@medsphere.com. 
*/
#include <stdio.h>

#include <stdlib.h>
#include <security/pam_appl.h>

#include "authdata.h"

extern int myconv(int n, const struct pam_message **msg, struct pam_response **resp, void *data);

int dopam(int count, char *user, char *password, char *pam_mod)
{
  int pam_err;
  pam_handle_t *pamh;
  struct pam_conv pamc;
  authdata adata;

  if (password && *password!='\0')
    adata.password = password;
  else
    return 0;

  if (user && *user!='\0')
    adata.user = user;
  else
    return 0;

  if (!pam_mod || *pam_mod=='\0')
    pam_mod = "openvista";

  /* initialize PAM */
  pamc.conv = &myconv;
  pamc.appdata_ptr = &adata;
  pam_start(pam_mod, adata.user, &pamc, &pamh);

  /* authenticate the applicant */
  if ((pam_err = pam_authenticate(pamh, 0)) != PAM_SUCCESS)
    goto pamerr;
  if ((pam_err = pam_acct_mgmt(pamh, 0)) != PAM_SUCCESS)
    goto pamerr;

  /* establish the requested credentials */
  if ((pam_err = pam_setcred(pamh, PAM_ESTABLISH_CRED)) != PAM_SUCCESS)
    goto pamerr;

  pam_end(pamh, pam_err);
  return 1;

pamerr:
  pam_end(pamh, pam_err);
  return 0;
}

