/*
* Copyright (C) 2009 Medsphere Systems Corporation
*
* This program is free software; you can redistribute it and/or modify it
* solely under the terms of the GNU Affero General Public License version 3 as
* published by the Free Software Foundation.
* 
* This program is distributed in the hope that it will be useful, but WITHOUT
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License
* for more details.
* 
* You should have received a copy of the GNU Affero General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses>.
* 
* You can contact Medsphere Systems Corporation headquarters at 1917 Palomar 
* Oaks Way, Suite 200, Carlsbad, CA 92008 or at legal@medsphere.com. 
*/

#include <unistd.h>

void gtmserver(int count, int connfd, const char *cmd) {
  int child_id=0;
  if (!(child_id=vfork())) { /* note assignment */
    /* fork again. Child exits and is reaped so as not to be a zombie.
       Grandchild is the actual client, which will be reaped by init. */
    if (!vfork()) {
      dup2(connfd, STDIN_FILENO);
      dup2(connfd, STDOUT_FILENO);
      execlp("mumps", "mumps", "-run", cmd, (char*)0);
      /* we should never get here, but fall through to exit we it do */
    }
    _exit(0); /* Do not do atexit() callbacks */
  } else if (child_id>0) {
    int status;
    waitpid(child_id, &status, 0);
  }
}
